Rel (X:Set) : Type
    = X -> X -> Set

Reflexive (|X:Set)(R:Rel X) : Set
    = (x:X) -> R x x

Symmetrical (|X:Set)(R:Rel X) : Set
    = (x1,x2:X) |-> R x1 x2 -> R x2 x1
Transitive (|X:Set)(R:Rel X) : Set
    = (x1,x2,x3:X) |-> R x1 x2 -> R x2 x3 -> R x1 x3


data Exp =  App (x:Exp) (y:Exp) | Z | Add | S

postulate (==) : Exp -> Exp -> Set
postulate ref (|x:Exp) : x == x
postulate sym (|x:Exp) (|y:Exp) : x == y -> y == x
postulate tran (|x:Exp) (|y:Exp) (|z:Exp) : x == y -> y == z -> x == z

data chain (x:Exp)
   = Dir (y:Exp) (p:x == y) | Chain (y:Exp) (p:x == y) (q:chain y)

last (x:Exp)(c:chain x) : Exp
    = case c of 
        (Dir y p) -> y
        (Chain y p q) -> last y q

tacEq (x:Exp)(c:chain x) : x == (last x c)
    = case c of 
        (Dir y p) -> p
        (Chain y p q) -> tran p (tacEq y q)

($) (|A:Set) (|B: A -> Set)(f : (a:A) -> B a) (a :A) : B a
($) = f a


postulate addZ (|x:Exp) : App (App Add x) Z == x
postulate addS (|x:Exp) (|y:Exp) : App (App Add x) (App S y) == App S (App (App Add x) y)

postulate congL (|x:Exp) (|y:Exp) (|z:Exp) : x == y -> App x z == App y z
postulate congR (|x:Exp) (|y:Exp) (|z:Exp) : x == y -> App z x == App z y

lem1 (|x:Exp) (|y:Exp) (h: App (App Add Z) x == x) : App (App Add Z) (App S x) == App S x
lem1 = tacEq (App (App Add Z) (App S x)) 
       (Chain (App S (App (App Add Z) x)) addS 
       (Dir (App@_ S x) (congR h)))



postulate Nat : Exp -> Set

postulate NZ : Nat Z
postulate NS (|x:Exp) : Nat x -> Nat (App S x)

data Inclus (Q,P:Exp -> Set) = Lam (h:(x:Exp) -> Q x -> P x)

postulate indN (|P:Exp -> Set) : P Z -> ((x:Exp) -> P x -> P (App S x)) -> Inclus Nat P

test : Inclus Nat (\ x -> App (App Add Z) x == x) 
test = indN 
         addZ
         (\ x -> \ h -> 
            tacEq (App (App Add Z) (App S x)) 
            (Chain (App S (App (App Add Z) x)) addS 
            (Dir (App@_ S x) (congR h))))

test1 (|x:Exp) : Inclus Nat (\ y -> App (App Add (App S x)) y == App (App Add x) (App S y))
test1 = indN
           (tacEq (App (App Add (App S x)) Z) 
            (Chain (App S x) addZ 
            (Chain (App S (App (App Add x) Z)) (congR (sym addZ)) 
            (Dir (App@_ (App Add x) (App S Z)) (sym addS)))))
           (\x1 -> \ h -> 
                tacEq    (App (App Add (App S x)) (App S x1)) 
                   (Chain (App S (App (App Add (App S x)) x1)) addS
                   (Chain (App S (App (App Add x) (App S x1))) (congR h)
                   (Dir (App@_ (App Add x) (App S (App S x1))) (sym addS)))))